#!/usr/bin/python -d   
import sys
import xml.etree.ElementTree
import xml.etree.ElementPath
import hal
from PyQt4 import QtCore,QtGui,uic
from functools import partial

form_class, base_class = uic.loadUiType("mygui.ui")
     
class MyWidget (QtGui.QWidget, form_class):
    def __init__(self,parent=None,filename=None,selected=[],flag=0,*args):
        QtGui.QWidget.__init__(self,parent,*args)
        print filename
        self.setupUi(self)
        QtCore.QObject.connect(self.pushButton, QtCore.SIGNAL("clicked()"), self.textEdit.clear )
        QtCore.QObject.connect(self.lineEdit, QtCore.SIGNAL("returnPressed()"), self.add_entry)
        
        try:
            self.halcomp = hal.component("qtvcp")
        except:
            print "*** QT VCP ERROR:    Asking for a HAL component using a name that already exists."
            sys.exit(0)

        # parse for HAL objects:
        root = xml.etree.ElementTree.parse("mygui.ui")
        for node in root.getiterator('widget'):
            # print what the tag and attributes looks like
            #print node.tag, node.attrib
            widgetclass = node.attrib.get('class')
            name = node.attrib.get('name')
            #print widgetclass,name
            if widgetclass =="QDial":
                self.make_hal_output(name)
                QtCore.QObject.connect(self.dial, QtCore.SIGNAL("valueChanged(int)"), partial(self.value_changed,name))
        self.halcomp.ready()

    def add_entry(self):
        self.lineEdit.selectAll()
        self.lineEdit.cut()
        self.textEdit.append("")
        self.textEdit.paste()

    def make_hal_output(self,widget):
        self.halcomp.newpin(widget, hal.HAL_FLOAT, hal.HAL_OUT)

    def value_changed(self,name):
        sender = self.sender()
        self.lcdNumber.display(sender.value())
        self.halcomp[name] = sender.value()

    def closeEvent(self, event):
        self.halcomp.exit()

if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    form = MyWidget(None,"filename")
    form.show()
    app.exec_()
    print "the end"
